package pc.entity;

import java.util.Date;

import ca.stfx.logic.cwf.engine.base.entity.PersistantCapableDTO;

public class PatientDTO extends PersistantCapableDTO {

	public static final Integer LOCATION_HOME = new Integer(0);
	public static final Integer LOCATION_HOSPITAL = new Integer(1);
	
	public static final Integer MALE = new Integer(0);
	public static final Integer FEMALE = new Integer(1);
	
	private String lastName;
	private String firstName;
	private String birthDate;
	private String address1;
	private String address2;
	private String zip;
	private String country;
	private String phoneNumber;
	private int location;
	private float height;
	private float weight;
	private String specialComment;
	private Long homeServiceId;
	private String hospitalEntryDate;
	private String receivedBy;
	private Long formalCaregiverId;
	
	public String getLastName() {
		return lastName;
	}
	public void setLastName(String lastName) {
		this.lastName = lastName;
	}
	public String getFirstName() {
		return firstName;
	}
	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}
	public String getBirthDate() {
		return birthDate;
	}
	public void setBirthDate(String birthDate) {
		this.birthDate = birthDate;
	}
	public String getAddress1() {
		return address1;
	}
	public void setAddress1(String address1) {
		this.address1 = address1;
	}
	public String getAddress2() {
		return address2;
	}
	public void setAddress2(String address2) {
		this.address2 = address2;
	}
	public String getZip() {
		return zip;
	}
	public void setZip(String zip) {
		this.zip = zip;
	}
	public String getPhoneNumber() {
		return phoneNumber;
	}
	public void setPhoneNumber(String phoneNumber) {
		this.phoneNumber = phoneNumber;
	}
	public int getLocation() {
		return location;
	}
	public void setLocation(int location) {
		this.location = location;
	}
	public float getHeight() {
		return height;
	}
	public void setHeight(float height) {
		this.height = height;
	}
	public float getWeight() {
		return weight;
	}
	public void setWeight(float weight) {
		this.weight = weight;
	}
	public String getSpecialComment() {
		return specialComment;
	}
	public void setSpecialComment(String specialComment) {
		this.specialComment = specialComment;
	}
	public String getCountry() {
		return country;
	}
	public void setCountry(String country) {
		this.country = country;
	}
	public Long getHomeServiceId() {
		return homeServiceId;
	}
	public void setHomeServiceId(Long homeServiceId) {
		this.homeServiceId = homeServiceId;
	}
	public String getHospitalEntryDate() {
		return hospitalEntryDate;
	}
	public void setHospitalEntryDate(String hospitalEntryDate) {
		this.hospitalEntryDate = hospitalEntryDate;
	}
	public String getReceivedBy() {
		return receivedBy;
	}
	public void setReceivedBy(String receivedBy) {
		this.receivedBy = receivedBy;
	}
	public Long getFormalCaregiverId() {
		return formalCaregiverId;
	}
	public void setFormalCaregiverId(Long formalCaregiverId) {
		this.formalCaregiverId = formalCaregiverId;
	}
	
	
	
}
