package pc.entity;

import java.util.Date;

import ca.stfx.logic.cwf.engine.base.entity.PersistantCapableDTO;

public class ReferralInfoDTO extends PersistantCapableDTO {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	public static final Integer PATIENT_APPROPRIATE = new Integer(1);
	public static final Integer PATIENT_NOT_APPROPRIATE = new Integer(0);
	
	private Date referralDate;
	private String referredBy;
	private Integer typeOfReferral;
	private String address;
	private String phoneNumber;
	private String referredTo;
	private Integer refFromContunuingCare;
	private Integer refFromConsultTeam;
	private String patientName;
	private String hcn;
	private Date dob;
	private Integer sex;
	private String metastuses;
	private String primaryDiagnosis;
	private Integer admissionDecision;
	private String comment;
	


	public Date getReferralDate() {
		return referralDate;
	}

	public void setReferralDate(Date referralDate) {
		this.referralDate = referralDate;
	}

	public String getReferredBy() {
		return referredBy;
	}

	public void setReferredBy(String referredBy) {
		this.referredBy = referredBy;
	}

	public Integer getTypeOfReferral() {
		return typeOfReferral;
	}

	public void setTypeOfReferral(Integer typeOfReferral) {
		this.typeOfReferral = typeOfReferral;
	}

	public String getAddress() {
		return address;
	}

	public void setAddress(String address) {
		this.address = address;
	}

	public String getPhoneNumber() {
		return phoneNumber;
	}

	public void setPhoneNumber(String phoneNumber) {
		this.phoneNumber = phoneNumber;
	}

	public String getReferredTo() {
		return referredTo;
	}

	public void setReferredTo(String referredTo) {
		this.referredTo = referredTo;
	}

	public Integer getRefFromContunuingCare() {
		return refFromContunuingCare;
	}

	public void setRefFromContunuingCare(Integer refFromContunuingCare) {
		this.refFromContunuingCare = refFromContunuingCare;
	}

	public Integer getRefFromConsultTeam() {
		return refFromConsultTeam;
	}

	public void setRefFromConsultTeam(Integer refFromConsultTeam) {
		this.refFromConsultTeam = refFromConsultTeam;
	}

	public String getPatientName() {
		return patientName;
	}

	public void setPatientName(String patientName) {
		this.patientName = patientName;
	}

	public String getHcn() {
		return hcn;
	}

	public void setHcn(String hcn) {
		this.hcn = hcn;
	}

	public Date getDob() {
		return dob;
	}

	public void setDob(Date dob) {
		this.dob = dob;
	}

	public Integer getSex() {
		return sex;
	}

	public void setSex(Integer sex) {
		this.sex = sex;
	}


	public String getMetastuses() {
		return metastuses;
	}

	public void setMetastuses(String metastuses) {
		this.metastuses = metastuses;
	}

	public String getPrimaryDiagnosis() {
		return primaryDiagnosis;
	}

	public void setPrimaryDiagnosis(String primaryDiagnosis) {
		this.primaryDiagnosis = primaryDiagnosis;
	}

	public Integer getAdmissionDecision() {
		return admissionDecision;
	}

	public void setAdmissionDecision(Integer admissionDecision) {
		this.admissionDecision = admissionDecision;
	}

	public String getComment() {
		return comment;
	}

	public void setComment(String comment) {
		this.comment = comment;
	}
	
}
