package pc.Overall.service.impl;

import ca.stfx.logic.cwf.engine.exception.IlligalOperationException;
import pc.Overall.service.Overall_Consult;
import pc.Overall.service.interfaces.IConsultService;
import pc.Overall.service.interfaces.IReceiveReferralService;
import pc.entity.ReferralInfoDTO;

public class ConsultServiceImpl extends Overall_Consult implements
		IConsultService {

	private IReceiveReferralService receiveReferralService;
	
	public ReferralInfoDTO updateInformation(ReferralInfoDTO referralInfo) throws IlligalOperationException {
		System.out.println("Received admission Decision " + referralInfo.getAdmissionDecision());
		referralInfo = receiveReferralService.updateReferralInfo(referralInfo);
		action(referralInfo.getInstanceId());
		return referralInfo;
	}

	public boolean isManual()
	{
		return true;
	}

	public void setReceiveReferralService(
			IReceiveReferralService receiveReferralService) {
		this.receiveReferralService = receiveReferralService;
	}
	
}
