package pc.TeamBuilding.service;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import ca.stfx.logic.cwf.engine.base.AbstractTask;
import ca.stfx.logic.cwf.engine.base.entity.InstanceInfo;
import ca.stfx.logic.cwf.engine.exception.IlligalOperationException;
import pc.util.Constants;
import ca.stfx.logic.cwf.engine.base.ActionInterface;
import ca.stfx.logic.cwf.engine.base.AbortInterface;

public class TeamBuilding_Formal_CGDone extends AbstractTask implements ActionInterface, AbortInterface{

	public final List<String> getAvailableOperations(long instanceId, Map<String, InstanceInfo> varMap){
		List<String> ops = new ArrayList<String>();

		if ( (varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK).getValue()  > 0 ) & (varMap.get(Constants._TeamBuilding_PC_Physician_SUC) != null && varMap.get(Constants._TeamBuilding_PC_Physician_SUC).getValue()  > 0 ) )
				ops.add( _ACTION );
		if ( (varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK).getValue()  > 0 ) & (varMap.get(Constants._TeamBuilding_Family_Physician_SUC) != null && varMap.get(Constants._TeamBuilding_Family_Physician_SUC).getValue()  > 0 ) )
				ops.add( _ACTION );
		if ( ((varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK).getValue()  == 0 ))  & (varMap.get(Constants._TeamBuilding_PC_Physician_SUC) != null && varMap.get(Constants._TeamBuilding_PC_Physician_SUC).getValue()  > 0) )
				ops.add( _ABORT );
		if ( ((varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK).getValue()  == 0 ))  & (varMap.get(Constants._TeamBuilding_Family_Physician_SUC) != null && varMap.get(Constants._TeamBuilding_Family_Physician_SUC).getValue()  > 0) )
				ops.add( _ABORT );
		if ( (varMap.get(Constants._TeamBuilding_Team_Ready_ABT_1) != null && varMap.get(Constants._TeamBuilding_Team_Ready_ABT_1).getValue()  > 0) & (varMap.get(Constants._M_TeamBuilding_PC_Physician) != null && varMap.get(Constants._M_TeamBuilding_PC_Physician).getValue()  > 0) )
				ops.add( _ABORT );
		if ( (varMap.get(Constants._TeamBuilding_Team_Ready_ABT_1) != null && varMap.get(Constants._TeamBuilding_Team_Ready_ABT_1).getValue()  > 0) & (varMap.get(Constants._M_TeamBuilding_Family_Physician) != null && varMap.get(Constants._M_TeamBuilding_Family_Physician).getValue()  > 0) )
				ops.add( _ABORT );
		return ops;
	}
	public void action(long instanceId)throws IlligalOperationException{
		Map<String, InstanceInfo> varMap = workflowEngineService.getVarMap(instanceId);

		if ( (varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK).getValue()  > 0 ) & (varMap.get(Constants._TeamBuilding_PC_Physician_SUC) != null && varMap.get(Constants._TeamBuilding_PC_Physician_SUC).getValue()  > 0 ) ){			
			resetValue(varMap, Constants._M_TeamBuilding_PC_Physician);
			resetValue(varMap, Constants._M_TeamBuilding_Family_Physician);
			incrValue(varMap, Constants._M_TeamBuilding_PC_Physician);
			decrValue(varMap, Constants._TeamBuilding_PC_Physician_SUC);
			incrValue(varMap, Constants._TeamBuilding_Formal_CGDone_SUC);
			workflowEngineService.updateTaskStatus(instanceId, varMap);
			return;
		}
		if ( (varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK).getValue()  > 0 ) & (varMap.get(Constants._TeamBuilding_Family_Physician_SUC) != null && varMap.get(Constants._TeamBuilding_Family_Physician_SUC).getValue()  > 0 ) ){			
			resetValue(varMap, Constants._M_TeamBuilding_PC_Physician);
			resetValue(varMap, Constants._M_TeamBuilding_Family_Physician);
			incrValue(varMap, Constants._M_TeamBuilding_Family_Physician);
			decrValue(varMap, Constants._TeamBuilding_Family_Physician_SUC);
			incrValue(varMap, Constants._TeamBuilding_Formal_CGDone_SUC);
			workflowEngineService.updateTaskStatus(instanceId, varMap);
			return;
		}
			throw new IlligalOperationException("Error executing workflow. Operation action is not allowed right now.");
	}
	public void abort(long instanceId)throws IlligalOperationException{
		Map<String, InstanceInfo> varMap = workflowEngineService.getVarMap(instanceId);

		if ( ((varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK).getValue()  == 0 ))  & (varMap.get(Constants._TeamBuilding_PC_Physician_SUC) != null && varMap.get(Constants._TeamBuilding_PC_Physician_SUC).getValue()  > 0) ){			
			decrValue(varMap, Constants._TeamBuilding_PC_Physician_SUC);
			incrValue(varMap, Constants._TeamBuilding_Formal_CGDone_ABT_0);
			workflowEngineService.updateTaskStatus(instanceId, varMap);
			return;
		}
		if ( ((varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK).getValue()  == 0 ))  & (varMap.get(Constants._TeamBuilding_Family_Physician_SUC) != null && varMap.get(Constants._TeamBuilding_Family_Physician_SUC).getValue()  > 0) ){			
			decrValue(varMap, Constants._TeamBuilding_Family_Physician_SUC);
			incrValue(varMap, Constants._TeamBuilding_Formal_CGDone_ABT_1);
			workflowEngineService.updateTaskStatus(instanceId, varMap);
			return;
		}
		if ( (varMap.get(Constants._TeamBuilding_Team_Ready_ABT_1) != null && varMap.get(Constants._TeamBuilding_Team_Ready_ABT_1).getValue()  > 0) & (varMap.get(Constants._M_TeamBuilding_PC_Physician) != null && varMap.get(Constants._M_TeamBuilding_PC_Physician).getValue()  > 0) ){			
			resetValue(varMap, Constants._M_TeamBuilding_PC_Physician);
			resetValue(varMap, Constants._M_TeamBuilding_Family_Physician);
			incrValue(varMap, Constants._TeamBuilding_Formal_CGDone_ABT_0);
			decrValue(varMap, Constants._TeamBuilding_Team_Ready_ABT_1);
			workflowEngineService.updateTaskStatus(instanceId, varMap);
			return;
		}
		if ( (varMap.get(Constants._TeamBuilding_Team_Ready_ABT_1) != null && varMap.get(Constants._TeamBuilding_Team_Ready_ABT_1).getValue()  > 0) & (varMap.get(Constants._M_TeamBuilding_Family_Physician) != null && varMap.get(Constants._M_TeamBuilding_Family_Physician).getValue()  > 0) ){			
			resetValue(varMap, Constants._M_TeamBuilding_PC_Physician);
			resetValue(varMap, Constants._M_TeamBuilding_Family_Physician);
			incrValue(varMap, Constants._TeamBuilding_Formal_CGDone_ABT_1);
			decrValue(varMap, Constants._TeamBuilding_Team_Ready_ABT_1);
			workflowEngineService.updateTaskStatus(instanceId, varMap);
			return;
		}
			throw new IlligalOperationException("Error executing workflow. Operation abort is not allowed right now.");
	}

	public String getTaskName(){
		return "TeamBuilding_Formal_CGDone";
	}
}
