package pc.TeamBuilding.service.impl;


import ca.stfx.logic.cwf.engine.exception.IlligalOperationException;



import pc.Overall.service.interfaces.IPatientRegistrationService;
import pc.TeamBuilding.service.TeamBuilding_Family_Physician;
import pc.TeamBuilding.service.interfaces.IFamilyPhysicianService;
import pc.entity.PatientDTO;
import pc.entity.PhysicianDTO;


public class FamilyPhysicianServiceImpl extends TeamBuilding_Family_Physician  implements IFamilyPhysicianService{
	
	private IPatientRegistrationService patientRegistrationService;



	public void assignFormalCaregiver(PatientDTO thePatient, PhysicianDTO thePhysician)throws IlligalOperationException{
		thePatient.setFormalCaregiverId(thePhysician.getId());
		patientRegistrationService.updatePatientInfo(thePatient);
		action(thePatient.getInstanceId());		
	}



	public void setPatientRegistrationService(
			IPatientRegistrationService patientRegistrationService) {
		this.patientRegistrationService = patientRegistrationService;
	}
		
	public boolean isManual()
	{
		return true;
	}
}
