package pc.TeamBuilding.service.impl;


import ca.stfx.logic.cwf.engine.exception.IlligalOperationException;




import pc.Overall.service.interfaces.IPatientRegistrationService;
import pc.TeamBuilding.service.TeamBuilding_PC_Physician;
import pc.TeamBuilding.service.interfaces.IPcPhysicianService;
import pc.entity.PatientDTO;
import pc.entity.PhysicianDTO;


public class PcPhysicianServiceImpl extends TeamBuilding_PC_Physician  implements IPcPhysicianService{
	
	private IPatientRegistrationService patientRegistrationService;



	public void assignFormalCaregiver(PatientDTO thePatient, PhysicianDTO thePhysician)throws IlligalOperationException{
		thePatient.setFormalCaregiverId(thePhysician.getId());
		patientRegistrationService.updatePatientInfo(thePatient);
		action(thePatient.getInstanceId());		
	}



	public void setPatientRegistrationService(
			IPatientRegistrationService patientRegistrationService) {
		this.patientRegistrationService = patientRegistrationService;
	}
		
	public boolean isManual()
	{
		return true;
	}
}
