package pc.TeamBuilding.service.interfaces;

import java.util.List;

import ca.stfx.logic.cwf.engine.base.AbortInterface;
import ca.stfx.logic.cwf.engine.base.FailInterface;
import ca.stfx.logic.cwf.engine.base.entity.PersistantCapableDTO;
import ca.stfx.logic.cwf.engine.exception.IlligalOperationException;
import pc.entity.HomeServiceDTO;
import pc.entity.PatientDTO;


public interface IHomeService extends AbortInterface, FailInterface {

	public HomeServiceDTO saveHomeService(HomeServiceDTO homeServiceInfo)throws IlligalOperationException;
	public HomeServiceDTO findHomeServiceInfoById(Long id);
	public List<HomeServiceDTO> findHomeServiceByZipCode(String zipCode);
	public HomeServiceDTO updateHomeServiceInfo(HomeServiceDTO homeServiceInfo);	
	public List<PersistantCapableDTO> findAllHomeService();
	public void allocateHomeServiceToPatient(PatientDTO thePatient, HomeServiceDTO homeServiceDTO)throws IlligalOperationException;
}
