package pc.Overall.dao.impl;

import java.util.List;

import org.springframework.orm.hibernate.support.HibernateDaoSupport;

import pc.Overall.dao.IAbstractDao;

import ca.stfx.logic.cwf.engine.base.entity.PersistantCapableDTO;

abstract public class AbstractDaoImpl extends HibernateDaoSupport implements IAbstractDao{

	protected Class entityClass;
	
	public AbstractDaoImpl(Class entityClass)
	{
		this.entityClass = entityClass;
	}
	
	public void saveEntity(PersistantCapableDTO theEntity)
	{
		getHibernateTemplate().save(theEntity);
	}
	
	public void updateEntity(PersistantCapableDTO theEntity)
	{
		getHibernateTemplate().update(theEntity);
	}
	
	public PersistantCapableDTO findById(Long id)
	{
		return (PersistantCapableDTO) getHibernateTemplate().get(entityClass, id);
	}


	public List<PersistantCapableDTO> findByInstanceId(Long instanceId) {
		return getHibernateTemplate().find("from " + entityClass.getName() + " where instanceId = " + instanceId );
	}
	
	public List<PersistantCapableDTO> findAllEntity()
	{
		return getHibernateTemplate().find("from " + entityClass.getName()+ "");
	}
}
