package pc.Overall.service;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import ca.stfx.logic.cwf.engine.base.AbstractTask;
import ca.stfx.logic.cwf.engine.base.entity.InstanceInfo;
import ca.stfx.logic.cwf.engine.exception.IlligalOperationException;
import pc.util.Constants;
import ca.stfx.logic.cwf.engine.base.ActionInterface;

public class Overall_Start extends AbstractTask implements ActionInterface{

	public final List<String> getAvailableOperations(long instanceId, Map<String, InstanceInfo> varMap){
		List<String> ops = new ArrayList<String>();

		if ( workflowEngineService.getVarMap(instanceId).size() == 0 )
				ops.add( _ACTION );
		return ops;
	}
	public void action(long instanceId)throws IlligalOperationException{

		if ( workflowEngineService.getVarMap(instanceId).size() == 0 ){			
			Map<String, InstanceInfo> varMap = Constants.createInstanceInfo(instanceId);
			incrValue(varMap, Constants._Overall_Start_SUC);
			workflowEngineService.updateTaskStatus(instanceId, varMap);
			return;
		}
			throw new IlligalOperationException("Error executing workflow. Operation action is not allowed right now.");
	}
	public void abort(long instanceId)throws IlligalOperationException{
		Map<String, InstanceInfo> varMap = workflowEngineService.getVarMap(instanceId);

			throw new IlligalOperationException("Error executing workflow. Operation abort is not allowed right now.");
	}

	public String getTaskName(){
		return "Overall_Start";
	}
}
