package pc.Overall.service.impl;

import pc.Overall.service.Overall_Patient_Valid;
import pc.Overall.service.interfaces.IReceiveReferralService;
import pc.entity.ReferralInfoDTO;

public class PatientValidServiceImpl extends Overall_Patient_Valid {

	private IReceiveReferralService receiveReferralService;
	
	public boolean getBranchCondition(long arg0, int arg1) {
		ReferralInfoDTO referralInfo = receiveReferralService.findReferralInfoByInstanceId(arg0);
		if(arg1 == 1)
		{
			if(referralInfo.getAdmissionDecision().equals(ReferralInfoDTO.PATIENT_APPROPRIATE))
				return true;
			else
				return false;
		}
		
		return true;
	}
	
	

	public void setReceiveReferralService(
			IReceiveReferralService receiveReferralService) {
		this.receiveReferralService = receiveReferralService;
	}
	
}
