package pc.TeamBuilding.service;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import ca.stfx.logic.cwf.engine.base.AbstractTask;
import ca.stfx.logic.cwf.engine.base.entity.InstanceInfo;
import ca.stfx.logic.cwf.engine.exception.IlligalOperationException;
import pc.util.Constants;
import ca.stfx.logic.cwf.engine.base.ActionInterface;
import ca.stfx.logic.cwf.engine.base.AbortInterface;
import ca.stfx.logic.cwf.engine.base.FailInterface;

public class TeamBuilding_MoveTo_Hospital extends AbstractTask implements ActionInterface, AbortInterface, FailInterface{

	public final List<String> getAvailableOperations(long instanceId, Map<String, InstanceInfo> varMap){
		List<String> ops = new ArrayList<String>();

		if ( (varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK).getValue()  > 0 ) & (varMap.get(Constants._TeamBuilding_Home_Service_SUC_1) != null && varMap.get(Constants._TeamBuilding_Home_Service_SUC_1).getValue()  > 0 ) )
				ops.add( _ACTION );
		if ( (varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK).getValue()  > 0 ) & (varMap.get(Constants._TeamBuilding_Home_Service_SUC_1) != null && varMap.get(Constants._TeamBuilding_Home_Service_SUC_1).getValue()  > 0 ) )
				ops.add( _ABORT );
		if ( (varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK).getValue()  > 0 ) & (varMap.get(Constants._TeamBuilding_Home_Service_SUC_1) != null && varMap.get(Constants._TeamBuilding_Home_Service_SUC_1).getValue()  > 0) )
				ops.add( _FAIL );
		if ( ((varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK).getValue()  == 0 ))  & (varMap.get(Constants._TeamBuilding_Home_Service_SUC_1) != null && varMap.get(Constants._TeamBuilding_Home_Service_SUC_1).getValue()  > 0 ) )
				ops.add( _ABORT );
		if ( (varMap.get(Constants._TeamBuilding_JOIN_13_ABT_1) != null && varMap.get(Constants._TeamBuilding_JOIN_13_ABT_1).getValue()  > 0 ) )
				ops.add( _ABORT );
		if ( (varMap.get(Constants._TeamBuilding_JOIN_13_ABT_1) != null && varMap.get(Constants._TeamBuilding_JOIN_13_ABT_1).getValue()  > 0 ) )
				ops.add( _FAIL );
		return ops;
	}
	public void action(long instanceId)throws IlligalOperationException{
		Map<String, InstanceInfo> varMap = workflowEngineService.getVarMap(instanceId);

		if ( (varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK).getValue()  > 0 ) & (varMap.get(Constants._TeamBuilding_Home_Service_SUC_1) != null && varMap.get(Constants._TeamBuilding_Home_Service_SUC_1).getValue()  > 0 ) ){			
			decrValue(varMap, Constants._TeamBuilding_Home_Service_SUC_1);
			incrValue(varMap, Constants._TeamBuilding_MoveTo_Hospital_SUC);
			workflowEngineService.updateTaskStatus(instanceId, varMap);
			return;
		}
			throw new IlligalOperationException("Error executing workflow. Operation action is not allowed right now.");
	}
	public void abort(long instanceId)throws IlligalOperationException{
		Map<String, InstanceInfo> varMap = workflowEngineService.getVarMap(instanceId);

		if ( (varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK).getValue()  > 0 ) & (varMap.get(Constants._TeamBuilding_Home_Service_SUC_1) != null && varMap.get(Constants._TeamBuilding_Home_Service_SUC_1).getValue()  > 0 ) ){			
			decrValue(varMap, Constants._TeamBuilding_Home_Service_SUC_1);
		
			decrValue(varMap, Constants._TeamBuilding_Home_Service_OK);
		if ( (varMap.get(Constants._TeamBuilding_Home_Service_OK) != null && varMap.get(Constants._TeamBuilding_Home_Service_OK).getValue()  == 0) ){
			
			resetValue(varMap, Constants._TeamBuilding_Assign_Caregivers_OK);
		}
			incrValue(varMap, Constants._TeamBuilding_MoveTo_Hospital_ABT);
			workflowEngineService.updateTaskStatus(instanceId, varMap);
			return;
		}
		if ( ((varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK).getValue()  == 0 ))  & (varMap.get(Constants._TeamBuilding_Home_Service_SUC_1) != null && varMap.get(Constants._TeamBuilding_Home_Service_SUC_1).getValue()  > 0 ) ){			
			decrValue(varMap, Constants._TeamBuilding_Home_Service_SUC_1);
		
			decrValue(varMap, Constants._TeamBuilding_Home_Service_OK);
		if ( (varMap.get(Constants._TeamBuilding_Home_Service_OK) != null && varMap.get(Constants._TeamBuilding_Home_Service_OK).getValue()  == 0) ){
			
			resetValue(varMap, Constants._TeamBuilding_Assign_Caregivers_OK);
		}
			incrValue(varMap, Constants._TeamBuilding_MoveTo_Hospital_ABT);
			workflowEngineService.updateTaskStatus(instanceId, varMap);
			return;
		}
		if ( (varMap.get(Constants._TeamBuilding_JOIN_13_ABT_1) != null && varMap.get(Constants._TeamBuilding_JOIN_13_ABT_1).getValue()  > 0 ) ){			
			decrValue(varMap, Constants._TeamBuilding_JOIN_13_ABT_1);
			incrValue(varMap, Constants._TeamBuilding_MoveTo_Hospital_ABT);
			workflowEngineService.updateTaskStatus(instanceId, varMap);
			return;
		}
			throw new IlligalOperationException("Error executing workflow. Operation abort is not allowed right now.");
	}
	public void fail(long instanceId)throws IlligalOperationException{
		Map<String, InstanceInfo> varMap = workflowEngineService.getVarMap(instanceId);

		if ( (varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK) != null && varMap.get(Constants._TeamBuilding_Assign_Caregivers_OK).getValue()  > 0 ) & (varMap.get(Constants._TeamBuilding_Home_Service_SUC_1) != null && varMap.get(Constants._TeamBuilding_Home_Service_SUC_1).getValue()  > 0) ){			
			decrValue(varMap, Constants._TeamBuilding_Home_Service_SUC_1);
			incrValue(varMap, Constants._TeamBuilding_MoveTo_Hospital_FAIL);
			incrValue(varMap, Constants._Overall_Team_Building_CFail);
			workflowEngineService.updateTaskStatus(instanceId, varMap);
			return;
		}
		if ( (varMap.get(Constants._TeamBuilding_JOIN_13_ABT_1) != null && varMap.get(Constants._TeamBuilding_JOIN_13_ABT_1).getValue()  > 0 ) ){			
			decrValue(varMap, Constants._TeamBuilding_JOIN_13_ABT_1);
			incrValue(varMap, Constants._TeamBuilding_MoveTo_Hospital_FAIL);
			incrValue(varMap, Constants._Overall_Team_Building_CFail);
			workflowEngineService.updateTaskStatus(instanceId, varMap);
			return;
		}
			throw new IlligalOperationException("Error executing workflow. Operation fail is not allowed right now.");
	}

	public String getTaskName(){
		return "TeamBuilding_MoveTo_Hospital";
	}
}
