package pc.TeamBuilding.service.impl;


import ca.stfx.logic.cwf.engine.exception.IlligalOperationException;



import pc.Overall.service.interfaces.IPatientRegistrationService;
import pc.TeamBuilding.service.TeamBuilding_MoveTo_Hospital;
import pc.TeamBuilding.service.interfaces.IMoveToHospitalService;
import pc.entity.PatientDTO;


public class MoveToHospitalServiceImpl extends TeamBuilding_MoveTo_Hospital  implements IMoveToHospitalService{
	
	private IPatientRegistrationService patientRegistrationService;



	public void movePatientToHospital(PatientDTO thePatient)throws IlligalOperationException{
		thePatient.setLocation(PatientDTO.LOCATION_HOSPITAL);
		patientRegistrationService.updatePatientInfo(thePatient);
		action(thePatient.getInstanceId());		
	}



	public void setPatientRegistrationService(
			IPatientRegistrationService patientRegistrationService) {
		this.patientRegistrationService = patientRegistrationService;
	}
		
	public boolean isManual()
	{
		return true;
	}
}
